diff --git a/src/bin/psql/tab-complete.c b/src/bin/psql/tab-complete.c
index b2671469aa..eb937bf156 100644
--- a/src/bin/psql/tab-complete.c
+++ b/src/bin/psql/tab-complete.c
@@ -3012,8 +3012,17 @@ psql_completion(const char *text, int start, int end)
 	else if (Matches("DECLARE", MatchAny))
 		COMPLETE_WITH("BINARY", "INSENSITIVE", "SCROLL", "NO SCROLL",
 					  "CURSOR");
+	else if (Matches("DECLARE", MatchAny, "BINARY"))
+		COMPLETE_WITH("INSENSITIVE", "SCROLL", "NO SCROLL", "CURSOR");
+	else if (Matches("DECLARE", MatchAny, "BINARY", "INSENSITIVE"))
+		COMPLETE_WITH("SCROLL", "NO SCROLL", "CURSOR");
+	else if (HeadMatches("DECLARE", MatchAny, "BINARY", "INSENSITIVE") &&
+			 TailMatches("SCROLL"))
+		COMPLETE_WITH("CURSOR");
 	else if (HeadMatches("DECLARE") && TailMatches("CURSOR"))
 		COMPLETE_WITH("WITH HOLD", "WITHOUT HOLD", "FOR");
+	else if (HeadMatches("DECLARE") && TailMatches("HOLD"))
+		COMPLETE_WITH("FOR");
 
 /* DELETE --- can be inside EXPLAIN, RULE, etc */
 	/* ... despite which, only complete DELETE with FROM at start of line */
